class PressureBoltTrail {
	constructor(game, texture, map, x, y, r, width, height, maxHeight, isAlive){
		this.game = game;
		
		// Rendering
		this.layer = "background";
		this.texture = texture;
		this.map = map;
		
		// Scale
		this.originalWidth = width;
		this.originalHeight = height;
		this.width = width;
		this.height = height;
		this.maxHeight = maxHeight;
		
		// Physics
		this.x = x * delta * 60;
		this.y = y * delta * 60;
		this.r = r * delta * 60;
		
		// Pressure Bolt Trail
		this.maxLife = 0.3;
		this.life = this.maxLife;
		this.isAlive = isAlive;
	}
	
	
	update(delta){
		return this.life -= delta;
	}
	
	
	draw(context, textures, atlas){
		var texture = this.texture,
			map = this.map;
		
		context.save();
		context.translate(this.x, this.y);
		context.rotate(this.r/180*Math.PI);
		
		context.globalAlpha = this.life / this.maxLife;
		// this.width = this.originalWidth * (2 - this.life / this.maxLife);
		// this.height = this.originalHeight * this.life / this.maxLife;
		
		context.drawImage(
			texture,
			
			// Sprite Crop Location
			map[0],
			map[1] + (this.isAlive ? 0 : map[3] * (1 - this.originalHeight/this.maxHeight)),
			map[2],
			map[3] * this.originalHeight/this.maxHeight,
			
			// Screen Space Location
			-this.width/2,
			-this.height/2,
			this.width,
			this.height
		);

		context.restore();
	}
}
